/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2013, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * PlantUML is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * PlantUML distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 *
 * Original Author:  Arnaud Roques
 * 
 * Revision $Revision: 10643 $
 *
 */
package net.sourceforge.plantuml.ugraphic;

import java.io.IOException;
import java.io.OutputStream;

import net.sourceforge.plantuml.Url;
import net.sourceforge.plantuml.graphic.StringBounder;

public abstract class UGraphic {
	/*
public*draw*x*y
void*draw*x*y
draw*(*0*0
Line
UGroup
UMotif

	 * 
	 */

	abstract public StringBounder getStringBounder();

	abstract public UParam getParam();

	abstract public void drawOldWay(UShape shape);

	public final void drawNewWay(double x, double y, UShape shape) {
		apply(new UTranslate(x, y)).drawOldWay(shape);
	}

	abstract public UGraphic apply(UChange change);

	abstract public ColorMapper getColorMapper();

	abstract public void startUrl(Url url);

	abstract public void closeAction();

	abstract public void writeImage(OutputStream os, String metadata, int dpi) throws IOException;
}
